%
%  parameter stepping example 1
%
clear all;
close all;
format long;
% make current value of lambda available globally
global lambda
%
% set up lambda vector
%
lambda_lo = 0.0;
lambda_hi = 1.0;
dlambda = 1.0e-2;
lambda_vec = [lambda_lo:dlambda:lambda_hi];
nlambda = length(lambda_vec);
%
%  reserve memory for solution matrix
%
x_storage = zeros(nlambda,1);
err_storage = zeros(nlambda,1);
%
%  initial guess for linear problem
% (doesn't matter)
%
x0 = 1.0;
%
%  parameter step
%
for i_lambda = 1:1:nlambda
% call Newton-Raphson
    lambda = lambda_vec(i_lambda);
    [x,err] = nrnd1(x0);
% store result
  x_storage(i_lambda) = x;
  err_storage(i_lambda) = err;
% update initial guess
  x0 = x;
end
 
%
%  plot result & error
%
figure(1)
plot(lambda_vec,x_storage,'k-o');
xlabel('stepping parameter lambda');
ylabel('solution');
 
figure(2)
semilogy(lambda_vec,err_storage,'k-o');
xlabel('stepping parameter lambda');
ylabel('relative error');

